/*  
		Bildquellen Verzeichnis 
		Version:     	1.0
		License:	CC 
		Last-Change:	10.01.2010

	Gregor Fellenz
	http://www.indesignblog.com/
*/

#target InDesign

// nur fr convenience
var _dok = app.activeDocument;

const myOldXUnits = app.activeDocument.viewPreferences.horizontalMeasurementUnits;
const myOldYUnits = app.activeDocument.viewPreferences.verticalMeasurementUnits;
const myOldInteraction = app.scriptPreferences.userInteractionLevel;

// Ab CS4 Skript Undo-Fhigkeit herstellen
try {
	if (app.version.substring(0,1) >= "6") {
		var undoName 	= "XMLImport.jsx";
		app.doScript(main, undefined , undefined,UndoModes.fastEntireScript , undoName ); 
	} 
	else {
		if (app.version.substring(0,1) == "5") { main(); }
		else { alert ("Es wird mindestens InDesign CS3 bentigt ...") }
	}
} 
catch (e) {
	alert("Es ist ein Fehler aufgetreten!\n" + e + 
			"\nZeile: " + e.line  +
			"\nSkript: " + e.fileName );
}


function main () {
	app.activeDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	app.activeDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;

		
	var _bildQuellen = new Array();
		
	for (var i =0 ; i < _dok.links.length; i++) {
		try {
			_bildQuellen.push([_dok.links[i].linkXmp.author, getPageByObject(_dok.links[i]).name] )
		} catch (e) {/* keine Metadaten vorhanden ... */ }
	}
	_bildQuellen.sort(sortCreator);	
	var _newPage = app.activeDocument.pages.add();
	var _tf = _newPage.textFrames.add()
	_tf.geometricBounds = [36,36,247.465 ,559.276 ];
	
	_tf.contents = "Bildquellenverzeichnis\r" +  _bildQuellen[0][0] + "\t"+ _bildQuellen[0][1];
	for (var i =1; i <_bildQuellen.length; i++) {
		if (_bildQuellen[i][0] == _bildQuellen[i-1][0])  _tf.contents = _tf.contents + ", " + _bildQuellen[i][1];
		else _tf.contents = _tf.contents + "\r" + _bildQuellen[i][0] + "\t"+ _bildQuellen[i][1];
	}	
		
		
	app.activeDocument.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
	app.activeDocument.viewPreferences.verticalMeasurementUnits = myOldYUnits;
	app.scriptPreferences.userInteractionLevel = myOldInteraction;
}

function sortCreator(a,b) {
	var x = dU(a[0]);
	var y = dU(b[0]);
	return(x==y)?0:(x>y)?1:-1;		
}
/** Deutsche Umlaute ersetzen */ 
function dU (a) {
	a = a.toLowerCase();
	a = a.replace(//g,"a");
	a = a.replace(//g,"o");
	a = a.replace(//g,"u");
	a = a.replace(//g,"s");	
	return	a;
}

function getPageByObject (myParent){ 
	switch(myParent.constructor.name){ 
		case "Page": 
			myParentName = myParent; 
			break; 
		case "Spread": 
			myParentName = "Pasteboard"; 
			break; 
		case "Application": 
			myParentName = ""; 
			break; 
		case "Character": 
			getPageByObject(myParent.parentTextFrames[0]); 
			break; 
		default: 
			getPageByObject(myParent.parent); 
			break; 
	} 
	return myParentName; 
}